<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: MST_UnidadMast.xml */
/* Generado: 2020-08-18 04:21:29 */

/* Validacion del contenido de los campos campos de la tabla MST_UnidadMast */
abstract class BaseMST_UnidadMastBV extends MST_UnidadMastBN
{
    /* Contiene la clase que valida el tipo de dato */
    private $o_Validator; // Contiene el objeto que realizara la validacion de tipo de dato.
    private $s_ValidatorMessage; // Contiene la ultima observacion de la validacion del tipo de dato.

    /* Constructor ( Establece la clase que valida los tipos de datos y establece los valores por defecto ) */
    public function __construct()
    {
        /* Establecemos el objeto que realizara la validacion del tipo de dato */
        $this->o_Validator = new utilValidDataType();

        /* Establecemos los valores por defecto */
    }

    /* Valida en tipo de dato */
    private function validateData( $u_Data, $s_DataType, $i_Length, $i_Decimal, $b_NotNull )
    {
        $this->s_ValidatorMessage = null;
        if( !$this->o_Validator->validate( $u_Data, $s_DataType, $i_Length, $i_Decimal, $b_NotNull ) )
        {
            $this->s_ValidatorMessage = $this->o_Validator->getMessage();
        }
        return is_null( $this->s_ValidatorMessage );
    }

    /* Valida y establece el valor del campo IdUnidad */
    public function setIdUnidad( $s_IdUnidad, $b_ValidateData = true )
    {
        if ( $b_ValidateData == true )
        {
            if ( !$this->validateData( $s_IdUnidad, "VARCHAR", 6, 0, false ) )
            {
                throw new Exception( "El campo IdUnidad ".strtolower( $this->s_ValidatorMessage ) );
            }
        }
        parent::setIdUnidad( $s_IdUnidad );
        return true;
    }

    /* Valida y establece el valor del campo DescripcionCorta */
    public function setDescripcionCorta( $s_DescripcionCorta, $b_ValidateData = true )
    {
        if ( $b_ValidateData == true )
        {
            if ( !$this->validateData( $s_DescripcionCorta, "VARCHAR", 40, 0, false ) )
            {
                throw new Exception( "El campo DescripcionCorta ".strtolower( $this->s_ValidatorMessage ) );
            }
        }
        parent::setDescripcionCorta( $s_DescripcionCorta );
        return true;
    }

    /* Valida y establece el valor del campo DescripcionExtranjera */
    public function setDescripcionExtranjera( $s_DescripcionExtranjera, $b_ValidateData = true )
    {
        if ( $b_ValidateData == true )
        {
            if ( !$this->validateData( $s_DescripcionExtranjera, "VARCHAR", 40, 0, false ) )
            {
                throw new Exception( "El campo DescripcionExtranjera ".strtolower( $this->s_ValidatorMessage ) );
            }
        }
        parent::setDescripcionExtranjera( $s_DescripcionExtranjera );
        return true;
    }

    /* Valida y establece el valor del campo CodigoSunat */
    public function setCodigoSunat( $s_CodigoSunat, $b_ValidateData = true )
    {
        if ( $b_ValidateData == true )
        {
            if ( !$this->validateData( $s_CodigoSunat, "VARCHAR", 10, 0, false ) )
            {
                throw new Exception( "El campo CodigoSunat ".strtolower( $this->s_ValidatorMessage ) );
            }
        }
        parent::setCodigoSunat( $s_CodigoSunat );
        return true;
    }

    /* Valida y establece el valor del campo UnidadTipo */
    public function setUnidadTipo( $s_UnidadTipo, $b_ValidateData = true )
    {
        if ( $b_ValidateData == true )
        {
            if ( !$this->validateData( $s_UnidadTipo, "VARCHAR", 2, 0, false ) )
            {
                throw new Exception( "El campo UnidadTipo ".strtolower( $this->s_ValidatorMessage ) );
            }
        }
        parent::setUnidadTipo( $s_UnidadTipo );
        return true;
    }

    /* Valida y establece el valor del campo NumeroDecimales */
    public function setNumeroDecimales( $i_NumeroDecimales, $b_ValidateData = true )
    {
        if ( $b_ValidateData == true )
        {
            if ( !$this->validateData( $i_NumeroDecimales, "INT", 11, 0, false ) )
            {
                throw new Exception( "El campo NumeroDecimales ".strtolower( $this->s_ValidatorMessage ) );
            }
        }
        parent::setNumeroDecimales( $i_NumeroDecimales );
        return true;
    }

    /* Valida y establece el valor del campo UnidadEquivalenteFlag */
    public function setUnidadEquivalenteFlag( $i_UnidadEquivalenteFlag, $b_ValidateData = true )
    {
        if ( $b_ValidateData == true )
        {
            if ( !$this->validateData( $i_UnidadEquivalenteFlag, "TINYINT", 4, 0, false ) )
            {
                throw new Exception( "El campo UnidadEquivalenteFlag ".strtolower( $this->s_ValidatorMessage ) );
            }
        }
        parent::setUnidadEquivalenteFlag( $i_UnidadEquivalenteFlag );
        return true;
    }

    /* Valida y establece el valor del campo UsoFraccionFlag */
    public function setUsoFraccionFlag( $i_UsoFraccionFlag, $b_ValidateData = true )
    {
        if ( $b_ValidateData == true )
        {
            if ( !$this->validateData( $i_UsoFraccionFlag, "TINYINT", 4, 0, false ) )
            {
                throw new Exception( "El campo UsoFraccionFlag ".strtolower( $this->s_ValidatorMessage ) );
            }
        }
        parent::setUsoFraccionFlag( $i_UsoFraccionFlag );
        return true;
    }

    /* Valida y establece el valor del campo EsUnidadMinimaFlag */
    public function setEsUnidadMinimaFlag( $i_EsUnidadMinimaFlag, $b_ValidateData = true )
    {
        if ( $b_ValidateData == true )
        {
            if ( !$this->validateData( $i_EsUnidadMinimaFlag, "TINYINT", 4, 0, false ) )
            {
                throw new Exception( "El campo EsUnidadMinimaFlag ".strtolower( $this->s_ValidatorMessage ) );
            }
        }
        parent::setEsUnidadMinimaFlag( $i_EsUnidadMinimaFlag );
        return true;
    }

    /* Valida y establece el valor del campo Estado */
    public function setEstado( $s_Estado, $b_ValidateData = true )
    {
        if ( $b_ValidateData == true )
        {
            if ( !$this->validateData( $s_Estado, "VARCHAR", 1, 0, false ) )
            {
                throw new Exception( "El campo Estado ".strtolower( $this->s_ValidatorMessage ) );
            }
        }
        parent::setEstado( $s_Estado );
        return true;
    }

    /* Valida y establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion, $b_ValidateData = true )
    {
        if ( $b_ValidateData == true )
        {
            if ( !$this->validateData( $d_FechaModificacion, "TIMESTAMP", 0, 0, false ) )
            {
                throw new Exception( "El campo FechaModificacion ".strtolower( $this->s_ValidatorMessage ) );
            }
        }
        parent::setFechaModificacion( $d_FechaModificacion );
        return true;
    }

    /* Valida y establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion, $b_ValidateData = true )
    {
        if ( $b_ValidateData == true )
        {
            if ( !$this->validateData( $s_UsuarioModificacion, "VARCHAR", 60, 0, false ) )
            {
                throw new Exception( "El campo UsuarioModificacion ".strtolower( $this->s_ValidatorMessage ) );
            }
        }
        parent::setUsuarioModificacion( $s_UsuarioModificacion );
        return true;
    }

    /* Valida y establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion, $b_ValidateData = true )
    {
        if ( $b_ValidateData == true )
        {
            if ( !$this->validateData( $d_FechaCreacion, "TIMESTAMP", 0, 0, false ) )
            {
                throw new Exception( "El campo FechaCreacion ".strtolower( $this->s_ValidatorMessage ) );
            }
        }
        parent::setFechaCreacion( $d_FechaCreacion );
        return true;
    }

    /* Valida y establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion, $b_ValidateData = true )
    {
        if ( $b_ValidateData == true )
        {
            if ( !$this->validateData( $s_UsuarioCreacion, "VARCHAR", 30, 0, false ) )
            {
                throw new Exception( "El campo UsuarioCreacion ".strtolower( $this->s_ValidatorMessage ) );
            }
        }
        parent::setUsuarioCreacion( $s_UsuarioCreacion );
        return true;
    }

    /* Valida el contenido del registro */
    public function validateRecord()
    {
        $this->setIdUnidad( $this->getIdUnidad(), false );
        $this->setDescripcionCorta( $this->getDescripcionCorta(), true );
        $this->setDescripcionExtranjera( $this->getDescripcionExtranjera(), true );
        $this->setCodigoSunat( $this->getCodigoSunat(), true );
        $this->setUnidadTipo( $this->getUnidadTipo(), true );
        $this->setNumeroDecimales( $this->getNumeroDecimales(), true );
        $this->setUnidadEquivalenteFlag( $this->getUnidadEquivalenteFlag(), true );
        $this->setUsoFraccionFlag( $this->getUsoFraccionFlag(), true );
        $this->setEsUnidadMinimaFlag( $this->getEsUnidadMinimaFlag(), true );
        $this->setEstado( $this->getEstado(), true );
        $this->setFechaModificacion( $this->getFechaModificacion(), true );
        $this->setUsuarioModificacion( $this->getUsuarioModificacion(), true );
        $this->setFechaCreacion( $this->getFechaCreacion(), true );
        $this->setUsuarioCreacion( $this->getUsuarioCreacion(), true );
        return true;
    }
}
?>